#include<iostream>
using namespace std;

#include "dco.hpp" // dco/c++ header

int main() {
  dco::gt1s<dco::gt1s<float>::type>::type x,y; // second-order tangent type variables
  dco::value(dco::value(x))=2; // set primal value of active input
  dco::value(dco::derivative(x))=1; // seed first first-order tangent
  dco::derivative(dco::value(x))=1; // seed second first-order tangent
  // second-order tangent value of active input is equal to zero by construction
  y=sin(x); // propagate (primal and tangents)
  cout << dco::value(dco::value(y)) << " "; // get primal value of active output
  cout << dco::value(dco::derivative(y)) << " "; // harvest first first-order tangent 
  cout << dco::derivative(dco::value(y)) << " "; // harvest second first-order tangent 
  cout << dco::derivative(dco::derivative(y)) << endl; // harvest second-order tangent 
  return 0;
}
